local function initULib( um )
	ULib = { VERSION=um:ReadFloat(), DEVELOPER_MODE=um:ReadBool() }

	if not ULib.DEVELOPER_MODE then
		local folder = "ULib/_cl_" .. string.format( "%.2f", ULib.VERSION )
		include( folder .. "/defines.lua" )
		include( folder .. "/misc.lua" )
		include( folder .. "/util.lua" )
		include( folder .. "/tables.lua" )
		include( folder .. "/messages.lua" )
		include( folder .. "/player.lua" )
		include( folder .. "/cl_util.lua" )
		include( folder .. "/autocomplete.lua" )
		include( folder .. "/draw.lua" )
		include( folder .. "/concommand.lua" )
		include( folder .. "/sh_ucl.lua" )
		include( folder .. "/uroundmenu.lua" )
		include( folder .. "/uroundbutton.lua" )
	else
		include( "ULib/shared/defines.lua" )
		include( "ULib/shared/misc.lua" )
		include( "ULib/shared/util.lua" )
		include( "ULib/shared/tables.lua" )
		include( "ULib/shared/messages.lua" )
		include( "ULib/shared/player.lua" )
		include( "ULib/client/util.lua" )
		include( "ULib/client/autocomplete.lua" )
		include( "ULib/client/draw.lua" )
		include( "ULib/shared/concommand.lua" )
		include( "ULib/shared/sh_ucl.lua" )
		include( "ULib/client/uroundmenu.lua" )
		include( "ULib/client/uroundbutton.lua" )
	end

	Msg( string.format( "This server is running ULib version %.2f.\n", ULib.VERSION ) )
	
end
usermessage.Hook( "ulib_init", initULib )