--[[
	Title: Draw

	Our client-side draw functions
]]

--[[
	Function: csayDraw

	Draws a csay text on the screen.

	Parameters:

		msg - The message to draw.
		color - *(Optional, defaults to 255, 255, 255, 255)* The color of the text
		duration - *(Optional, defaults to 5)* The length of the text
]]
function ULib.csayDraw( msg, color, duration )
	color = color or Color( 255, 255, 255, 255 )
	duration = duration or 5
	local function drawToScreen()
		draw.DrawText( msg, "TargetID", ScrW() * 0.5, ScrH() * 0.25, color, TEXT_ALIGN_CENTER )
	end

	hook.Add( "HUDPaint", "CSayHelperDraw", drawToScreen )
	timer.Simple( duration, hook.Remove, "HUDPaint", "CSayHelperDraw" )
end