if not ULib then
	ULib = {}
	require( "ulib" ) -- Our .dll

	Msg( "///////////////////////////////\n" )
	Msg( "//      Ulysses Library      //\n" )
	Msg( "///////////////////////////////\n" )
	Msg( "// Loading...                //\n" )

       	Msg( "//  shared/defines.lua       //\n" )
       	include( "ULib/shared/defines.lua" )
       	Msg( "//  shared/misc.lua          //\n" )
       	include( "ULib/shared/misc.lua" )
       	Msg( "//  shared/util.lua          //\n" )
       	include( "ULib/shared/util.lua" )
       	Msg( "//  shared/table.lua         //\n" )
       	include( "ULib/shared/tables.lua" )
       	Msg( "//  shared/player.lua        //\n" )
       	include( "ULib/shared/player.lua" )
       	Msg( "//  server/player.lua        //\n" )
       	include( "ULib/server/player.lua" )
       	Msg( "//  shared/messages.lua      //\n" )
       	include( "ULib/shared/messages.lua" )
       	Msg( "//  shared/concommand.lua    //\n" )
       	include( "ULib/shared/concommand.lua" )
       	Msg( "//  server/concommand.lua    //\n" )
       	include( "ULib/server/concommand.lua" )
       	Msg( "//  server/util.lua          //\n" )
       	include( "ULib/server/util.lua" )
       	Msg( "//  shared/sh_ucl.lua         //\n" )
       	include( "ULib/shared/sh_ucl.lua" )
       	Msg( "//  server/ucl.lua           //\n" )
       	include( "ULib/server/ucl.lua" )
       	Msg( "//  server/phys.lua          //\n" )
       	include( "ULib/server/phys.lua" )
	Msg( "//  server/player_ext.lua    //\n" )
	include( "server/player_ext.lua" )
	Msg( "//  server/entity_ext.lua    //\n" )
	include( "server/entity_ext.lua" )
	Msg( "// Load Complete!            //\n" )
	Msg( "///////////////////////////////\n" )

	AddCSLuaFile( "ULib/cl_init.lua" )
	AddCSLuaFile( "autorun/ulib_init.lua" )
	if not ULib.DEVELOPER_MODE then
		local folder = "ULib/_cl_" .. string.format( "%.2f", ULib.VERSION )
		local files = file.FindInLua( folder .. "/" .. "*.lua" )
		for _, file in ipairs( files ) do
			if file ~= "_generator.lua" then
				AddCSLuaFile( folder .. "/" .. file )
			end
		end
	else
		local folder = "ULib/shared"
		local files = file.FindInLua( folder .. "/" .. "*.lua" )
		for _, file in ipairs( files ) do
			AddCSLuaFile( folder .. "/" .. file )
		end
		
		local folder = "ULib/client"
		local files = file.FindInLua( folder .. "/" .. "*.lua" )
		for _, file in ipairs( files ) do
			AddCSLuaFile( folder .. "/" .. file )
		end
	end

	local files = file.FindInLua( "ULib/modules/*.lua" )
	if #files > 0 then
		for _, file in ipairs( files ) do
			print( "[ULIB] Loading module: " .. file )
			include( "ULib/modules/" .. file )
			AddCSLuaFile( "ULib/modules/" .. file )
		end
	end

	local function openULib( ply )
		umsg.Start( "ulib_init", ply )
			umsg.Float( ULib.VERSION )
			umsg.Bool( ULib.DEVELOPER_MODE )
		umsg.End()

		timer.Simple( 0.5, function() -- Make sure ULib loads first.
			for _, file in ipairs( files ) do
				ULib.sendLuaFunction( ply, "include", "ULib/modules/" .. file )
			end
		end )
	end
	hook.Add( "PlayerInitialSpawn", "OpenULib", openULib )
end