local meta = FindMetaTable( "Player" )

-- Return if there's nothing to add on to
if not meta then return end

function meta:DisallowNoclip( bool )
	self.NoNoclip = bool
end

function meta:DisallowSpawning( bool )
	self.NoSpawning = bool
end

local function tool( ply, tr, toolmode )
	if toolmode == "duplicator" and ply.NoSpawning then
		return false
	end
end
hook.Add( "CanTool", "ULXPlayerToolCheck", tool )

local function noclip( ply )
	if ply.NoNoclip then return false end
end
hook.Add( "PlayerNoClip", "ULXNoclipCheck", noclip )

local function spawnblock( ply )
	if ply.NoSpawning then return false end
end
hook.Add( "PlayerSpawnEffect", "ULXSpawnBlock", spawnblock )
hook.Add( "PlayerSpawnProp", "ULXSpawnBlock", spawnblock )
hook.Add( "PlayerSpawnNPC", "ULXSpawnBlock", spawnblock )
hook.Add( "PlayerSpawnVehicle", "ULXSpawnBlock", spawnblock )
hook.Add( "PlayerSpawnRagdoll", "ULXSpawnBlock", spawnblock )
hook.Add( "PlayerSpawnSENT", "ULXSpawnBlock", spawnblock )